;Vejle, 24. maj 1999                                                                        
;Lars Nielsen, Vejle DK
; This program is free, for all to enjoy
; No garantees what-so-ever
; 
;
;Version 1.0
;  Uses global 3D-constrain variables for "animation" of af MDT assembly model.
;  Variable values is remembered within a drawing session.
;
;Version 1.0a
;  Added filedia and cmddia
;
;Version 1.1: 11. august 1999
;  Added possibility to animate upto 5 individual variables.
;  Possibility for saving each animationstep as rendered pictures, BMP, TGA og TIFF ( default 800x600 24 bit, BMP=8bit )
;
;Animmain:
; Semianimation of a given global assembly variable, runs forever until [ESC] is pressed ( more times if needed ),
; PC-Speed is not checked, it runs as fast as possible.
;Animmain:
;   Varname:		Global 3D-constrain variablename
;   Startval:		Startvalue
;   Endval:		Endvalue
;   Stepval:		Stepvalue from start to end
;   Loop:		If <> nil:	Sequens steps from start to endvalues and then back to startvalue again
;                                       Good for linear movements ( cylinders etc. )
;			If=nil:		Sequens steps from start to endvalue and than start all over.
;                                       Good for angular movements ( 0-359 )
;REMARK!
;  There MUST be a local active part in the drawing
;  If run for a long period of time the PC RAM runs out ( due to MDT's use of UNDO-function )
;
;Other comments:
;  Errorhandler reestablishes values set by the routine, cmdecho, ucsicon, cursorsize, filedia, cmddia )
;    The routines use of these values gives a clean window, without icons cluttering up etc.


(defun C:animmain ()


(defun *ANIMERR* (msg)
  (done_dialog)
  (unload_dialog DCL_ID)
  (setq *error* OLDERR)
  (setq OLDERR nil)
  (setvar "CMDECHO" oldecho)
  (setvar "ucsicon" olducsicon )
  (setvar "CURSORSIZE" oldcursor )
  (setvar "FILEDIA" oldfiledia)
  (setvar "CMDDIA" oldcmddia)
  (if (/= nil msg)
      (princ msg )
  )
  (princ)
)

(defun initanim ()
  (if (= nil amdwgcolor )                            ;Check for MDT
           (progn
              (alert "\nThis program demands that\nAutoCAD Mechanical Desktop 3.0 TM\n is present")
              (exit)
           )
  )
  (if (not (findfile "anim_uk.dcl") )
           (progn
             (alert "\nAnim_uk.dcl can't be found in supportpath")
             (exit)
           )
  )
  (setq OLDERR *error*)
  (setq *error* *ANIMERR*)
  (setq oldecho (getvar "cmdecho") )               ; Remove commandline echo
  (setvar "cmdecho" 0 )
  (setq olducsicon (getvar "UCSICON"))
  (setvar "ucsicon" 0 )                            ; Turn off ucsicon
  (setq oldcursor (getvar "CURSORSIZE"))
  (setvar "CURSORSIZE" 1 )                         ; Minimize crosshair
  (setq oldfiledia (getvar "FILEDIA"))
  (setvar "FILEDIA" 0)
  (setq oldcmddia (getvar "CMDDIA"))
  (setvar "CMDDIA" 0)
  (setq DCL_ID (load_dialog "anim_uk.dcl") )
)

(defun loadvars ()

   (setq tempvar nil)
)
  
(defun runanim  ( Varname1 StartVal1 EndVal1 StepVal1 UpDnval1
                  Varname2 StartVal2 EndVal2 StepVal2 UpDnval2
                  Varname3 StartVal3 EndVal3 StepVal3 UpDnval3
                  Varname4 StartVal4 EndVal4 StepVal4 UpDnval4
                  Varname5 StartVal5 EndVal5 StepVal5 UpDnval5 )
  (setq loop 1)
  (Setq tt1 startval1)
  (Setq tt2 startval2)
  (Setq tt3 startval3)
  (Setq tt4 startval4)
  (Setq tt5 startval5)
  (Setq tt1up 1)
  (Setq tt2up 1)
  (Setq tt3up 1)
  (Setq tt4up 1)
  (Setq tt5up 1)
  (setq piccounter 0)
  (if (= picgen 1)
      (alert "Render options can be defined before starting routine, <Render to viewport> <skip dialogue>")
  )
    (if (= picgen 1)                                          ;Generate pictures for movie
        (progn
          (c:rpref "DEST" "FILE")                             ;Destination: file
          (C:rpref "SELECT" "ALL")                            ;Select all on screen
          (c:rpref "STYPE" "ASCAN")                           ;Photo real
          (c:rpref "TOGGLE" "CACHE" "OFF")                    ;Turn of picturecache, ( picture is changed constantly)
          (c:rpref "TOGGLE" "SKIPRDLG" "ON")                  ;disable render dialogue
          (if (= tifgen 1)
              (progn
                (c:rfileopt "TIFF" 800 600 1.0 "C24" "COMP")  ;TIFF parameters
          	(setq filmext "TIF" comptype "PACK")
              )
 	  )
          (if (= tgagen 1)
              (progn
                (c:rfileopt "TGA" 800 600 1.0 "C24" 1 "COMP" "UP")     ;TGA parameters
          	(setq filmext "TGA" comptype "RLE")

              )
 	  )
          (if (= bmpgen 1)
              (progn
              (c:rfileopt "BMP" 800 600 1.0 "C8")                    ;BMP parameters
              (setq filmext "BMP" comptype "NONE")
            )
        )
      )
  )
  (amupdate "assembly")
  (while loop
    (setq filecounter (substr (strcat "0000" (itoa piccounter)) (- (strlen (strcat "0000" (itoa piccounter))) 3)))
    (if (= picgen 1) (c:render (strcat "frame" filecounter "." filmext)))
    (setq piccounter (+ 1 piccounter))
    (if (/= "" Varname1)
        (progn
           (amvars "global" "edit" VarName1 (itoa tt1) )      ;Update global variabeelbefore change of counter ( start with initialvalue )
           (if (= tt1up 1)                                    ;If counting up
               (if (< tt1 Endval1)                            ;Check if counter is less than end value
                   (setq tt1 (+ tt1 stepval1))                ;Inc counter with stepvalue
                   (if (= updnval1 1)                         ;1 corresponds to restart
                       (progn
                         (setq tt1 minval1)                   ;Reset counter to startvalue
                         (If  (= picgen 1)		      ;Exit loop if generating pictures
                              (setq loop nil)
                         )
                       )
                       (progn
                          (setq tt1up 0)                      ;Begin counting down
                          (setq tt1 (- tt1 stepval1))         ;Subtract stepvalue from counter
                       )
                   )
               )
               (if (> tt1 minval1)                            ;Ells, if counter is bigger than minvalue
                   (setq tt1 (- tt1 stepval1))                ;Reduce with stepvalue
                   (progn                                     ;Ells
                      (If (= picgen 1)		              ;Exit loop if generating pictures
                          (setq loop nil)
                      )
                      (setq tt1up 1)                          ;Start counting up again
                      (setq tt1 (+ tt1 stepval1))              ;Add stepvalue to counter
                   )
               )
           )
        )
    )
    (if (/= "" Varname2)
        (progn
           (amvars "global" "edit" VarName2 (itoa tt2) )      
           (if (= tt2up 1)                                    
               (if (< tt2 Endval2)                            
                   (setq tt2 (+ tt2 stepval2))                
                   (if (= updnval2 1)                         
                       (setq tt2 minval2)                     
                       (progn
                          (setq tt2up 0)                      
                          (setq tt2 (- tt2 stepval2))         
                       )
                   )
               )
               (if (> tt2 minval2)                            
                   (setq tt2 (- tt2 stepval2))                
                   (progn                                     
                      (setq tt2up 1)                          
                      (setq tt2 (+ tt2 stepval2))             
                   )
               )
           )
        )
    )
    (if (/= "" Varname3)
        (progn
           (amvars "global" "edit" VarName3 (itoa tt3) )      
           (if (= tt3up 1)                                    
               (if (< tt3 Endval3)                            
                   (setq tt3 (+ tt3 stepval3))                
                   (if (= updnval3 1)                         
                       (setq tt3 minval3)                     
                       (progn
                          (setq tt3up 0)                      
                          (setq tt3 (- tt2 stepval3))         
                       )
                   )
               )
               (if (> tt3 minval3)                            
                   (setq tt3 (- tt3 stepval3))                
                   (progn                                     
                      (setq tt3up 1)                          
                      (setq tt3 (+ tt3 stepval3))             
                   )
               )
           )
        )
    )
    (if (/= "" Varname4)
        (progn
           (amvars "global" "edit" VarName4 (itoa tt4) )      
           (if (= tt4up 1)                                    
               (if (< tt4 Endval4)                            
                   (setq tt4 (+ tt4 stepval4))                
                   (if (= updnval4 1)                         
                       (setq tt4 minval4)                     
                       (progn
                          (setq tt4up 0)                      
                          (setq tt4 (- tt4 stepval4))         
                       )
                   )
               )
               (if (> tt4 minval4)                            
                   (setq tt4 (- tt4 stepval4))                
                   (progn                                     
                      (setq tt4up 1)                          
                      (setq tt4 (+ tt4 stepval4))             
                   )
               )
           )
        )
    )
    (if (/= "" Varname5)
        (progn
           (amvars "global" "edit" VarName5 (itoa tt5) )      
           (if (= tt5up 1)                                    
               (if (< tt5 Endval5)                            
                   (setq tt5 (+ tt5 stepval5))                
                   (if (= updnval5 1)                         
                       (setq tt5 minval5)                     
                       (progn
                          (setq tt5up 0)                      
                          (setq tt5 (- tt5 stepval5))         
                       )
                   )
               )
               (if (> tt5 minval5)                            
                   (setq tt5 (- tt5 stepval5))                
                   (progn                                     
                      (setq tt5up 1)                          
                      (setq tt5 (+ tt5 stepval5))             
                   )
               )
           )
        )
    )
    (amupdate "assembly")                                              ;Update picture
  )                 
)


  (initanim)
  (loadvars)
  (if (= oldvarname1 nil)
      (progn
        (setq varname1 "V")
        (setq oldvarname1 "V")
      )
      (setq varname1 oldvarname1)
  )
  (if (= oldvarname2 nil)
      (progn
        (setq varname2 "")
        (setq oldvarname2 "")
      )
      (setq varname2 oldvarname2)
  )
  (if (= oldvarname3 nil)
      (progn
        (setq varname3 "")
        (setq oldvarname3 "")
      )
      (setq varname3 oldvarname3)
  )
  (if (= oldvarname4 nil)
      (progn
        (setq varname4 "")
        (setq oldvarname4 "")
      )
      (setq varname4 oldvarname4)
  )
  (if (= oldvarname5 nil)
      (progn
        (setq varname5 "")
        (setq oldvarname5 "")
      )
      (setq varname5 oldvarname5)
  )
  (if (= oldminval1 nil)
      (progn
        (setq minval1 0)
        (setq oldminval1 0)
      )
      (setq minval1 oldminval1)
  )
  (if (= oldminval2 nil)
      (progn
        (setq minval2 0)
        (setq oldminval2 0)
      )
      (setq minval2 oldminval2)
  )
  (if (= oldminval3 nil)
      (progn
        (setq minval3 0)
        (setq oldminval3 0)
      )
      (setq minval3 oldminval3)
  )
  (if (= oldminval4 nil)
      (progn
        (setq minval4 0)
        (setq oldminval4 0)
      )
      (setq minval4 oldminval4)
  )
  (if (= oldminval5 nil)
      (progn
        (setq minval5 0)
        (setq oldminval5 0)
      )
      (setq minval5 oldminval5)
  )
  (if (= oldmaxval1 nil)
      (progn
        (setq maxval1 359)                 ; default 0 to 359 degrees, assumet angular rotation
        (setq oldmaxval1 359)
      )
      (setq maxval1 oldmaxval1)
  )
  (if (= oldmaxval2 nil)
      (progn
        (setq maxval2 359)                 
        (setq oldmaxval2 359)
      )
      (setq maxval2 oldmaxval2)
  )
  (if (= oldmaxval3 nil)
      (progn
        (setq maxval3 359)                 
        (setq oldmaxval3 359)
      )
      (setq maxval3 oldmaxval3)
  )
  (if (= oldmaxval4 nil)
      (progn
        (setq maxval4 359)                 
        (setq oldmaxval4 359)
      )
      (setq maxval4 oldmaxval4)
  )
  (if (= oldmaxval5 nil)
      (progn
        (setq maxval5 359)                 
        (setq oldmaxval5 359)
      )
      (setq maxval5 oldmaxval5)
  )
  (if (= oldstepval1 nil)
      (progn
        (setq stepval1 1)
        (setq oldstepval1 1)
      )
      (setq stepval1 oldstepval1)
  )
  (if (= oldstepval2 nil)
      (progn
        (setq stepval2 1)
        (setq oldstepval2 1)
      )
      (setq stepval2 oldstepval2)
  )
  (if (= oldstepval3 nil)
      (progn
        (setq stepval3 1)
        (setq oldstepval3 1)
      )
      (setq stepval3 oldstepval3)
  )
  (if (= oldstepval4 nil)
      (progn
        (setq stepval4 1)
        (setq oldstepval4 1)
      )
      (setq stepval4 oldstepval4)
  )
  (if (= oldstepval5 nil)
      (progn
        (setq stepval5 1)
        (setq oldstepval5 1)
      )
      (setq stepval5 oldstepval5)
  )
  (if (= oldupdn1 nil)
      (progn
        (setq updn1 1)
        (setq oldupdn1 1)
      )
      (setq updn1 oldupdn1)
  ) 
  (if (= oldupdn2 nil)
      (progn
        (setq updn2 1)
        (setq oldupdn2 1)
      )
      (setq updn2 oldupdn2)
  ) 
  (if (= oldupdn3 nil)
      (progn
        (setq updn3 1)
        (setq oldupdn3 1)
      )
      (setq updn3 oldupdn3)
  ) 
  (if (= oldupdn4 nil)
      (progn
        (setq updn4 1)
        (setq oldupdn4 1)
      )
      (setq updn4 oldupdn4)
  ) 
  (if (= oldupdn5 nil)
      (progn
        (setq updn5 1)
        (setq oldupdn5 1)
      )
      (setq updn5 oldupdn5)
  )
  (if (= oldpicgen nil)
      (progn
        (setq picgen 0)
        (setq oldpicgen 0)
      )
      (setq picgen oldpicgen)
  )
  (setq tifgen 0)
  (setq tgagen 0)
  (setq bmpgen 0)
  (if (not (new_dialog "anim_uk" DCL_ID) ) (exit))
  (set_tile "varname1" varname1 )
  (set_tile "gvarmin1" (itoa minval1 ) )
  (set_tile "gvarmax1" (itoa maxval1 ) )
  (set_tile "stepval1" (itoa stepval1 ) )
  (set_tile "updn_key1" (itoa updn1 ) )
  (set_tile "varname2" varname2 )
  (set_tile "gvarmin2" (itoa minval2 ) )
  (set_tile "gvarmax2" (itoa maxval2 ) )
  (set_tile "stepval2" (itoa stepval2 ) )
  (set_tile "updn_key2" (itoa updn2 ) )
  (set_tile "varname3" varname3 )
  (set_tile "gvarmin3" (itoa minval3 ) )
  (set_tile "gvarmax3" (itoa maxval3 ) )
  (set_tile "stepval3" (itoa stepval3 ) )
  (set_tile "updn_key3" (itoa updn3 ) )
  (set_tile "varname4" varname4 )
  (set_tile "gvarmin4" (itoa minval4 ) )
  (set_tile "gvarmax4" (itoa maxval4 ) )
  (set_tile "stepval4" (itoa stepval4 ) )
  (set_tile "updn_key4" (itoa updn4 ) )
  (set_tile "varname5" varname5 )
  (set_tile "gvarmin5" (itoa minval5 ) )
  (set_tile "gvarmax5" (itoa maxval5 ) )
  (set_tile "stepval5" (itoa stepval5 ) )
  (set_tile "updn_key5" (itoa updn5 ) )
  (set_tile "picgen" (itoa picgen))
  (set_tile "bmpgen" (itoa bmpgen))
  (set_tile "tgagen" (itoa tgagen))
  (set_tile "tifgen" (itoa tifgen))
  (action_tile "picgen" "(setq picgen (atoi $value))")
  (action_tile "bmpgen" "(setq bmpgen (atoi $value))")
  (action_tile "tgagen" "(setq tgagen (atoi $value))")
  (action_tile "tifgen" "(setq tifgen (atoi $value))")
  (action_tile "varname1" "(setq varname1 $value)")
  (action_tile "gvarmin1" "(setq minval1 (atoi $value ))")
  (action_tile "gvarmax1" "(setq maxval1 (atoi $value ))")
  (action_tile "stepval1" "(setq stepval1 (atoi $value ))")
  (action_tile "updn_key1" "(setq updn1 (atoi $value ))")
  (action_tile "varname2" "(setq varname2 $value)")
  (action_tile "gvarmin2" "(setq minval2 (atoi $value ))")
  (action_tile "gvarmax2" "(setq maxval2 (atoi $value ))")
  (action_tile "stepval2" "(setq stepval2 (atoi $value ))")
  (action_tile "updn_key2" "(setq updn2 (atoi $value ))")
  (action_tile "varname3" "(setq varname3 $value)")
  (action_tile "gvarmin3" "(setq minval3 (atoi $value ))")
  (action_tile "gvarmax3" "(setq maxval3 (atoi $value ))")
  (action_tile "stepval3" "(setq stepval3 (atoi $value ))")
  (action_tile "updn_key3" "(setq updn3 (atoi $value ))")
  (action_tile "varname4" "(setq varname4 $value)")
  (action_tile "gvarmin4" "(setq minval4 (atoi $value ))")
  (action_tile "gvarmax4" "(setq maxval4 (atoi $value ))")
  (action_tile "stepval4" "(setq stepval4 (atoi $value ))")
  (action_tile "updn_key4" "(setq updn4 (atoi $value ))")
  (action_tile "varname5" "(setq varname5 $value)")
  (action_tile "gvarmin5" "(setq minval5 (atoi $value ))")
  (action_tile "gvarmax5" "(setq maxval5 (atoi $value ))")
  (action_tile "stepval5" "(setq stepval5 (atoi $value ))")
  (action_tile "updn_key5" "(setq updn5 (atoi $value ))")
  (action_tile "accept" "(done_dialog 1)")
  (setq what_next (start_dialog) )
  (cond
    ((= 1 what_next)
       (progn
         (setq oldvarname1 varname1 oldminval1 minval1 oldmaxval1 maxval1 oldstepval1 stepval1 oldupdn1 updn1)
         (setq oldvarname2 varname2 oldminval2 minval2 oldmaxval2 maxval2 oldstepval2 stepval2 oldupdn2 updn2)
         (setq oldvarname3 varname3 oldminval3 minval3 oldmaxval3 maxval3 oldstepval3 stepval3 oldupdn3 updn3)
         (setq oldvarname4 varname4 oldminval4 minval4 oldmaxval4 maxval4 oldstepval4 stepval4 oldupdn4 updn4)
         (setq oldvarname5 varname5 oldminval5 minval5 oldmaxval5 maxval5 oldstepval5 stepval5 oldupdn5 updn5)
         (runanim varname1 minval1 maxval1 stepval1 updn1
                  varname2 minval2 maxval2 stepval2 updn2
                  varname3 minval3 maxval3 stepval3 updn3
                  varname4 minval4 maxval4 stepval4 updn4
                  varname5 minval5 maxval5 stepval5 updn5)
       )
    )
  )  
  (unload_dialog DCL_ID)
  (setq *error* OLDERR)
  (setvar "CMDECHO" oldecho)
  (setvar "UCSICON" olducsicon )
  (setvar "CURSORSIZE" oldcursor )
  (setvar "FILEDIA" oldfiledia)
  (setvar "CMDDIA" oldcmddia)
  (princ)
)
(princ "\nWrite: ANIMMAIN")
